Архитекторам и проектировщикам
| Правила | Регистрация | Пользователи | Поиск | Сообщения за день | Все разделы прочитаны |  Справка по форуму | Файлообменник |

Вернуться   Форум DWG.RU > Программное обеспечение > AutoCAD > Разделить или разрезать штриховку полилинией

Разделить или разрезать штриховку полилинией

Ответ
Поиск в этой теме
Непрочитано 22.09.2017, 10:53 #1
Разделить или разрезать штриховку полилинией
Djeker
 
Регистрация: 09.07.2014
Сообщений: 22

Как разделить или разрезать штриховку по полилинии?
Не обрезать стандартной командой, что потом исчезает кусок, а именно поделить / разрезать , чтобы сохранить обе части штриховки

Вот к примеру есть жёлтая штриховка и полилиния. (сверху на рисунке)
Какую команду набрать или какой лисп запустить , чтобы последовательно выбрать штриховку, затем полилинию, нажать Ентер и штриховка поделилась на 2 части?

Миниатюры
Нажмите на изображение для увеличения
Название: forum.jpg
Просмотров: 47
Размер:	145.4 Кб
ID:	193917  

Просмотров: 7064
 
Непрочитано 22.09.2017, 10:57
1 | #2
Bull

Конструктор по сути (машиностроитель)
 
Регистрация: 10.10.2005
Набережные Челны (это где КамАЗ)
Сообщений: 11,412


штатно никак
__________________
Век живи, век учись - ...
Bull вне форума  
 
Автор темы   Непрочитано 22.09.2017, 11:03
#3
Djeker


 
Регистрация: 09.07.2014
Сообщений: 22


Цитата:
Сообщение от Bull Посмотреть сообщение
штатно никак
Может у кого лисп есть...
Обрезать , потом опять штриховать проблемно с большим количеством =(
Djeker вне форума  
 
Непрочитано 22.09.2017, 11:03
1 | #4
Profan


 
Регистрация: 25.12.2005
Москва
Сообщений: 13,663


Запомни штриховку. Сотри ее. Начерти разделительную полилинию. Заново создай штриховку в получившихся областях.
Profan вне форума  
 
Непрочитано 22.09.2017, 11:14
#5
Bull

Конструктор по сути (машиностроитель)
 
Регистрация: 10.10.2005
Набережные Челны (это где КамАЗ)
Сообщений: 11,412


Offtop:
Цитата:
Сообщение от Profan Посмотреть сообщение
Запомни штриховку. Сотри ее. Начерти разделительную полилинию. Заново создай штриховку в получившихся областях.
точно программист...


----- добавлено через ~1 мин. -----
Цитата:
Сообщение от Djeker Посмотреть сообщение
Может у кого лисп есть...
вам тоже в ветку "программирование" (только что одного направляли по другому вопросу)
__________________
Век живи, век учись - ...
Bull вне форума  
 
Непрочитано 22.09.2017, 11:18
#6
Profan


 
Регистрация: 25.12.2005
Москва
Сообщений: 13,663


Да с лиспом вряд ли намного быстрее будет. Все равно тыкать...
Profan вне форума  
 
Непрочитано 22.09.2017, 12:14
#7
kp+

идущий по граблям
 
Регистрация: 26.05.2005
Днепройт
Сообщений: 4,460


Цитата:
Сообщение от Djeker Посмотреть сообщение
Может у кого лисп есть...
Тут есть
https://lispbox.wordpress.com/2015/02/01/hatch-split/
но как-то через одно место написано, у меня сходу не пошел. попробуй, конечно, разобраться
__________________
Одно меня лишь радует - я это вижу сам! (С)
kp+ вне форума  
 
Непрочитано 22.09.2017, 18:22
1 | #8
zenon

Остекляем!!! Алюминим!!!
 
Регистрация: 21.02.2005
Москва
Сообщений: 3,546
<phrase 1=


скопировать штриховку на саму себя (дабы получилось 2), с помощью команды _trim обрезать.
__________________
Мы можем делать быстро, качественно и недорого, выбирайте любые 2 условия.:search:
zenon вне форума  
 
Непрочитано 22.09.2017, 18:24
1 | #9
mindchamber


 
Регистрация: 29.07.2017
Сообщений: 170


Цитата:
Сообщение от zenon Посмотреть сообщение
скопировать штриховку на саму себя (дабы получилось 2), с помощью команды _trim обрезать.
Или создать 2 полилинии и обрезать между ними штриховку.
mindchamber на форуме  
 
Автор темы   Непрочитано 24.09.2017, 20:50
| 1 #10
Djeker


 
Регистрация: 09.07.2014
Сообщений: 22


Если у кого-нибудь есть выход на разработчиков, то сообщите им о предложении сделать возможность деления штриховки полилинией.
Штриховка нужный инструмент , а по возможности её делить/объединять как-то дискриминируют.

Лет 5 назад довелось бывать на конференции автодеска в мск, там давали слово представителю сообщества пользователей в России, может с ним кто имеет связь)
Djeker вне форума  
 
Непрочитано 24.09.2017, 22:26
#11
trir


 
Регистрация: 18.12.2010
Сообщений: 4,380


ST_Difference
trir вне форума  
 
Непрочитано 11.01.2021, 22:26
#12
mindchamber


 
Регистрация: 29.07.2017
Сообщений: 170


Цитата:
Сообщение от kp+ Посмотреть сообщение
Тут есть
https://lispbox.wordpress.com/2015/02/01/hatch-split/
но как-то через одно место написано, у меня сходу не пошел. попробуй, конечно, разобраться
Подниму тему. Почему-то не работает данный lisp. Я так понял он разрезает все штриховки по выбранной полилинии? Есть ли его рабочая версия? Поделитесь пожалуйста.
mindchamber на форуме  
 
Непрочитано 12.01.2021, 09:10
1 | #13
mihael_b

geodezist
 
Регистрация: 07.09.2004
israel
Сообщений: 27
<phrase 1=


https://areatester.com/
mihael_b вне форума  
 
Непрочитано 12.01.2021, 10:38
#14
mindchamber


 
Регистрация: 29.07.2017
Сообщений: 170


Цитата:
Сообщение от mihael_b Посмотреть сообщение
Не совсем то. Ладно, будем по старинке через _trim
mindchamber на форуме  
 
Непрочитано 12.01.2021, 11:06
#15
Oleg T


 
Регистрация: 27.12.2011
Сообщений: 1,161


Если кому интересно, в приложенном файле некий алгоритм с использованием стандартных средств.
(в автокаде не проверял, сделано в аналоге - брикскад)
ЗЫ
Нет, в Автокаде не работает
Вложения
Тип файла: dwg
DWG 2013
Разделение штриховок.dwg (54.7 Кб, 9 просмотров)

Последний раз редактировалось Oleg T, 12.01.2021 в 13:07.
Oleg T вне форума  
 
Непрочитано 12.01.2021, 11:17
#16
VitalyAF

инженер
 
Регистрация: 19.07.2005
Россия
Сообщений: 2,384
Отправить сообщение для VitalyAF с помощью Skype™


Цитата:
Разделить или разрезать штриховку полилинией
Для чего????? В 99%-ах это изобретение велосипеда...!
Если это условная линия реза, например оч. длинная деталь, то есть
стандартные линии с маскировкой части изображения и штриховки в т.ч.!
К тому же можно кастомную создать, за узлы тянуть, подгоняя под деталь...

Последний раз редактировалось VitalyAF, 12.01.2021 в 11:31.
VitalyAF на форуме  
 
Непрочитано 12.01.2021, 11:48
#17
Кулик Алексей aka kpblc
Moderator

LISP, C# (ACAD 200[9,12,13,14])
 
Регистрация: 25.08.2003
С.-Петербург
Сообщений: 37,922


VitalyAF, в чистом ACAD никаких "стандартных линий с маскировкой" нет, насколько мне известно.
__________________

---
Обращение ко мне - на "ты".
Все, что сказано - личное мнение.
Кулик Алексей aka kpblc вне форума  
 
Непрочитано 12.01.2021, 12:15
#18
VitalyAF

инженер
 
Регистрация: 19.07.2005
Россия
Сообщений: 2,384
Отправить сообщение для VitalyAF с помощью Skype™


Цитата:
Сообщение от Кулик Алексей aka kpblc Посмотреть сообщение
VitalyAF, в чистом ACAD никаких "стандартных линий с маскировкой" нет, насколько мне известно.
Там дело не в линии а в определённом цвете полигона... 160-ый, если память не изменяет...
не думаю, что для этого вертикалка нужна...
...впрочем мне пофиг, пусть режет штриховку, говорят через руки быстрее доходит...
...а я уже давно переобулся на Fusion 360..., мелкой моторикой уже не занимаюсь))

PS
...вспомнил, я последний раз делал такой разрез в конторе архитектурной, к-рая исключительно
в голом акаде рукоделием занималась... Это те, к-рые 11-ть листов весь день распечатывают,
и потом не разговаривают друг с другом, из-за споров на топорах - у кого версия проекта актуальней...
Лет 5-7 т.н. это было, может и более...))
Так что ищите и обрящете!

Последний раз редактировалось VitalyAF, 12.01.2021 в 12:38.
VitalyAF на форуме  
 
Непрочитано 12.01.2021, 12:18
| 1 #19
mindchamber


 
Регистрация: 29.07.2017
Сообщений: 170


Цитата:
Сообщение от VitalyAF Посмотреть сообщение
Для чего????? В 99%-ах это изобретение велосипеда...!
Если это условная линия реза, например оч. длинная деталь, то есть
стандартные линии с маскировкой части изображения и штриховки в т.ч.!
К тому же можно кастомную создать, за узлы тянуть, подгоняя под деталь...
Например на генплане участок разделен на много участков, а штриховка озеленения и дорог одна, а экспертиза просит площади в технико-экономических показателях на каждый участок отдельно. Поэтому очень бы пригодился инструмент по разрезу штриховки полилиниями.
mindchamber на форуме  
 
Непрочитано 12.01.2021, 12:47
#20
VitalyAF

инженер
 
Регистрация: 19.07.2005
Россия
Сообщений: 2,384
Отправить сообщение для VitalyAF с помощью Skype™


Цитата:
...а штриховка озеленения и дорог одна...
автора на выход, с вещами...! Пусть в зад вертает штриховку и делает как надо!
VitalyAF на форуме  
 
Непрочитано 13.01.2021, 10:26
2 | #21
koMon


 
Регистрация: 26.09.2017
Сообщений: 898


Цитата:
Сообщение от mindchamber Посмотреть сообщение
Почему-то не работает данный lisp.
прикольная идея резать штриховку через объёмное преобразование с последующим отпечатком (imprint) режущей кривой. я написал лисп по мотивам ссылки. всяческих проверок нет. получаемые на выходе порезки штриховки штрихуют регионы, которые затем удаляются.

Код:
[Выделить все]
 
*****************************************************************************************************************************************

(vl-load-com) 			;unless Boxa did not shorten the participants list

;*****************************************************************************************************************************************

(defun c:split_hatch (/
						hatch_to_split
						sample_hatch
						hatch_splitter
						hatch_plane
						splitted_parts_variant
						summary_region
						splitted_hatch_index
					 )

;	*************************************************************************************************************

	(defun add_hatch (object_to_hatch sample_hatch / hatch_object)
		(vl-cmdf "_-hatch" "_p" (vla-get-patternname sample_hatch)
								(vla-get-patternscale sample_hatch)
								(vla-get-patternangle sample_hatch)
						   "_s" (vlax-vla-object->ename object_to_hatch)
						   	"" ""
		)
	    (setq hatch_object (vlax-ename->vla-object (entlast)))
		(foreach property '(
								BackgroundColor Elevation EntityTransparency GradientAngle GradientCentered
								GradientColor1 GradientColor2 GradientName HatchObjectType HatchStyle ISOPenWidth
								Layer Linetype LinetypeScale Lineweight Material Normal Origin PatternDouble
								PatternSpace PlotStyleName TrueColor Visible
						   )
			(vl-catch-all-apply (read (strcat "vla-put-" (vl-symbol-name property)))
								(list hatch_object
									  (vl-catch-all-apply (read (strcat "vla-get-" (vl-symbol-name property)))
														  (list sample_hatch)
									  )
								)
			)
		)
		(vla-put-associativehatch hatch_object :vlax-false)
	)

;	*************************************************************************************************************

	(vla-startundomark (vla-get-activedocument (vlax-get-acad-object)))
	(redraw (setq hatch_to_split (car (entsel "\nВыберите штриховку для разделения: "))) 3)
	(setq sample_hatch (vla-copy (vlax-ename->vla-object hatch_to_split))
		  hatch_splitter (car (entsel "\nВыберите делящий примитив: "))
		  splitted_hatch_index 0
	)
	(setvar 'cmdecho 0)
	(vl-cmdf "._hatchedit" hatch_to_split "_b" "_r" "_y")
	(vl-cmdf "._planesurf" "_o" (entlast) "")
	(setq hatch_plane (entlast))
	(vla-erase (vlax-ename->vla-object hatch_to_split))
	(vl-cmdf "._imprint" hatch_plane hatch_splitter "_n" "")
	(vl-cmdf "._explode" hatch_plane)
	(setq splitted_parts_variant (vla-explode (vlax-ename->vla-object (setq summary_region (entlast)))))
	(vla-erase (vlax-ename->vla-object summary_region))
	(foreach _region (vlax-safearray->list (vlax-variant-value splitted_parts_variant))
		(add_hatch _region sample_hatch)
		(vla-erase _region)
		(setq splitted_hatch_index (1+ splitted_hatch_index))
	)
	(vla-erase sample_hatch)
	(princ (strcat "\nИз выбранной штриховки получено частей: " (itoa splitted_hatch_index)))
	(vla-endundomark (vla-get-activedocument (vlax-get-acad-object)))
	(setvar 'cmdecho 1)
	(princ)
)

;*****************************************************************************************************************************************
koMon на форуме  
 
Непрочитано 13.01.2021, 10:36
#22
mindchamber


 
Регистрация: 29.07.2017
Сообщений: 170


Цитата:
Сообщение от koMon Посмотреть сообщение
прикольная идея резать штриховку через объёмное преобразование с последующим отпечатком (imprint) режущей кривой. я написал лисп по мотивам ссылки. всяческих проверок нет. получаемые на выходе порезки штриховки штрихуют регионы, которые затем удаляются.
Спасибо, то что надо!

Offtop: Если бы можно было выбрать сразу несколько штриховок и полилиний, то было бы идеально , сори за наглость)
mindchamber на форуме  
 
Непрочитано 13.01.2021, 10:40
#23
trir


 
Регистрация: 18.12.2010
Сообщений: 4,380


Цитата:
Например на генплане участок разделен на много участков, а штриховка озеленения и дорог одна, а экспертиза просит площади в технико-экономических показателях на каждый участок отдельно. Поэтому очень бы пригодился инструмент по разрезу штриховки полилиниями.
Цитата:
Если бы можно было выбрать сразу несколько штриховок и полилиний, то было бы идеально
SQL!
trir вне форума  
 
Непрочитано 13.01.2021, 11:18
#24
koMon


 
Регистрация: 26.09.2017
Сообщений: 898


Цитата:
Сообщение от mindchamber Посмотреть сообщение
сразу несколько штриховок и полилиний
попарно/комплектами?
koMon на форуме  
 
Непрочитано 13.01.2021, 11:37
#25
mindchamber


 
Регистрация: 29.07.2017
Сообщений: 170


Цитата:
Сообщение от koMon Посмотреть сообщение
попарно/комплектами?
Было бы удобно так:
split_hatch
ENTER
Выбор штриховок (хорошо если бы можно было использовать инструмент лассо)
ENTER
Выбор полилиний (тоже хорошо было бы использовать лассо)
ENTER
mindchamber на форуме  
 
Непрочитано 13.01.2021, 11:51
#26
trir


 
Регистрация: 18.12.2010
Сообщений: 4,380


Цитата:
Было бы удобно так:
split_hatch
ENTER
Выбор штриховок (хорошо если бы можно было использовать инструмент лассо)
ENTER
Выбор полилиний (тоже хорошо было бы использовать лассо)
ENTER
Легко!

Код:
[Выделить все]
select p.id, p.geom.STDifference(l.geom) as geom1, p.geom.STIntersection(l.geom) as geom2
from Леса as l, Участки as p

Последний раз редактировалось trir, 13.01.2021 в 12:33.
trir вне форума  
 
Непрочитано 13.01.2021, 17:36
#27
koMon


 
Регистрация: 26.09.2017
Сообщений: 898


mindchamber, хорошо бы картинку посмотреть
koMon на форуме  
 
Непрочитано 13.01.2021, 18:06
#28
mindchamber


 
Регистрация: 29.07.2017
Сообщений: 170


Цитата:
Сообщение от koMon Посмотреть сообщение
mindchamber, хорошо бы картинку посмотреть
Вот например - необходимо обрезать эти штриховки по красному контуру. Это только часть штриховок, выбирать по отдельности каждый раз сначала штриховку, потом полилинию долго получается.
Миниатюры
Нажмите на изображение для увеличения
Название: Screenshot_1.png
Просмотров: 24
Размер:	257.5 Кб
ID:	233521  
mindchamber на форуме  
Ответ
Вернуться   Форум DWG.RU > Программное обеспечение > AutoCAD > Разделить или разрезать штриховку полилинией

Размещение рекламы
Опции темы Поиск в этой теме
Поиск в этой теме:

Расширенный поиск


Похожие темы
Тема Автор Раздел Ответов Последнее сообщение
Как разделить деталь на две части и сохранить общюю длину runmy AutoCAD 2 13.01.2017 08:54
SW 2014 Возможно ли в эскизе выбрать только штриховку? voverrr SolidWorks 0 10.09.2016 12:37
Как сделать штриховку по периметру окружности? dimond7 AutoCAD 12 05.07.2016 14:58
как штриховку обрисовать полилинией? Alex II AutoCAD 3 16.07.2013 10:29
Помогите разрезать солиды.. skalder AutoCAD 34 10.01.2008 11:46